//RahmenVerschieben_401d.js
// 29.01.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Verschiebt Rahmen

//Basiert auf "AdjustLayout.jsx" (CS3), geliefert von Adobe
//deutsche Dialogtexte von Gerald Singelmann ("Layout anpassen.jsx")
//Scripterweiterung von Hans Haesler am 29.01.2015

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument geffnet ist, welches Rahmen enthlt
if (app.documents.length != 0) {
	if (app.documents[0].pageItems.length == 0) {
		alert ("Das Dokument enthlt keine Rahmen.", "Achtung", true);
		exit();
	}
}
else {
	alert ("Es ist kein Dokument offen.", "Achtung", true);
	exit();
}

// das Dokument im Vordergrund
curDoc = app.documents[0];

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs  = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var evenX   = prefVal[0]*1;
	var evenY   = prefVal[1]*1;
	var oddX    = prefVal[2]*1;
	var oddY    = prefVal[3]*1;
	var ignVal1 = prefVal[4];
	if (ignVal1 == "true") { lckFrm = true; }
	else { lckFrm = false; }
	var ignVal2 = prefVal[5];
	if (ignVal2 == "true") { lckLay = true; }
	else { lckLay = false; }
	var ignVal3  = prefVal[6];
	if (ignVal3 == "true") { invLay = true; }
	else { invLay = false; }
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde, 
	// auf die folgenden Vorgabenwerte zurckgreifen
	var evenX  = 0;
	var evenY  = 0;
	var oddX   = 0;
	var oddY   = 0;
	var lckFrm = true;
	var lckLay = true;
	var invLay = true;
}

// die aktuellen Masseinheiten speichern
var curXUnits = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
var curYUnits = (curDoc.viewPreferences.verticalMeasurementUnits)*1;

// den Wert der aktuellen Seitennumerierungsoption speichern ...
var oldPageNumbering = app.generalPreferences.pageNumbering;
// ... und sicherstellen, dass die Abschnitts-Numerierung eingestellt ist
app.generalPreferences.pageNumbering = PageNumberingOptions.section;

// eventuell im Speicher vorhandene Dialoge entfernen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}
// den Dialog vorbereiten
var pageNames = getPageNames();
var labelWidth = 86;
var aDialog = app.dialogs.add({name:"Rahmen verschieben"});
with (aDialog.dialogColumns.add()) {
	with (borderPanels.add()) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"Von Seite:", minWidth:labelWidth-10});
				}
				with (dialogColumns.add()) {
					var startPageDropdown = dropdowns.add({stringList:pageNames, selectedIndex:0});
				}
			}
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"Bis Seite:", minWidth:labelWidth-10});
				}
				with (dialogColumns.add()) {
					var endPageDropdown = dropdowns.add({stringList:pageNames, selectedIndex:pageNames.length-1});
				}
			}
		}
	}
	with (borderPanels.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Gerade Seiten"});
					staticTexts.add({staticLabel:""});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontal:", minWidth:labelWidth});
					var evenXField = measurementEditboxes.add({editValue:evenX, editUnits:curXUnits});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertikal:", minWidth:labelWidth});
					var evenYField = measurementEditboxes.add({editValue:evenY, editUnits:curYUnits});
				}
			}
		}
	}
	with (borderPanels.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ungerade Seiten"});
					staticTexts.add({staticLabel:""});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontal:", minWidth:labelWidth});
					var oddXField = measurementEditboxes.add({editValue:oddX, editUnits:curXUnits});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertikal:", minWidth:labelWidth});
					var oddYField = measurementEditboxes.add({editValue:oddY, editUnits:curYUnits});
				}
			}
		}
	}
	with (dialogRows.add()) {
		staticTexts.add({staticLabel:"Aktiviertes bercksichtigen:"});
	}
	with (borderPanels.add()) {
		staticTexts.add({staticLabel:"", minWidth:6});
		with (dialogColumns.add()) {
			var lckFrmField = checkboxControls.add({staticLabel:"gesperrte Rahmen",checkedState:lckFrm});
			var lckLayField = checkboxControls.add({staticLabel:"gesperrte Ebenen",checkedState:lckLay});
			var invLayField = checkboxControls.add({staticLabel:"unsichtbare Ebenen",checkedState:invLay});
		}
	}
}
// den Dialog anzeigen
if (aDialog.show() == true) {
	var startPageName = pageNames[startPageDropdown.selectedIndex];
	var endPageName = pageNames[endPageDropdown.selectedIndex];
	var doLckFrm = lckFrmField.checkedState;
	var doLckLay = lckLayField.checkedState;
	var doInvLay = invLayField.checkedState;
	var evenX = evenXField.editValue;
	var evenY = evenYField.editValue;
	var oddX  = oddXField.editValue;
	var oddY  = oddYField.editValue;
	aDialog.destroy();
	// die Eingaben prfen
	var okay = false;
	var testList = new Array(evenX, evenY, oddX, oddY);
	for (var t=0; t<4; t++) {
		if (testList[t] != 0) {
			okay = true;
			break;
		}
	}
	if (okay == false) {
		alert ("Alle vier Werte sind Null.", "Stop", true);
		app.generalPreferences.pageNumbering = oldPageNumbering;
		exit();
	}
	// die Liste der Einstellungen ...
	var prefsList = new Array(evenX, evenY, oddX, oddY, doLckFrm, doLckLay, doInvLay);
	// ... in eine Textkette verwandeln ...
	var prefString = prefsList.join("\n");
	// ... und zur Funktion schicken, welche sie in eine Datei schreibt ...
	writeResult(prefString);
	// die Funktion aufrufen, welche die Ebenen entsperrt
	if (doLckLay == true) {
		var lockList = unlockLayers();
	}
	// die Funktion aufrufen, welche die Ebenen sichtbar macht
	if (doInvLay == true) {
		var visiList = showLayers();
	}
	// und zur Funktion, welche die Aktionen ausfhrt
	adjustPages(evenX, evenY, oddX, oddY, startPageName, endPageName, doLckFrm, doLckLay, doInvLay);
	// falls entsperrt, die Ebenen wieder sperren
	if (doLckLay == true) {
		lockLayers(lockList);
	}
	// falls sichtbar gemacht, die Ebenen wieder unsichtbar machen
	if (doInvLay == true) {
		hideLayers(visiList);
	}
	// den Vorgaben die ursprnglichen Werte zuweisen
	curDoc.viewPreferences.horizontalMeasurementUnits = curXUnits;
	curDoc.viewPreferences.verticalMeasurementUnits   = curYUnits;
	app.generalPreferences.pageNumbering = oldPageNumbering;
	
	// das Ende der Aktion verknden
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	// eine kleine Pause
	$.sleep(500);
	// das Fenster schliessen
	dlog.close();
}
else {
	aDialog.destroy();
}


////////////////////////////// die Funktionen  ////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/RahmenVerschieben401.txt");
	}
	else {
		var f = new File("~/Library/Preferences/RahmenVerschieben401.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/RahmenVerschieben401.txt");
	}
	else {
		var f = new File("~/Library/Preferences/RahmenVerschieben401.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Ebenen entsperren //////////////////////////////////////////////////////////////////
function unlockLayers() {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var lockList = new Array();
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (curLayer.locked == true) {
			curLayer.locked = false;
			lockList.push(true);
		}
		else {
			lockList.push(false);
		}
	}
	return (lockList);
}

// die Ebenen sichtbar machen /////////////////////////////////////////////////////////////
function showLayers() {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var visiList = new Array();
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (curLayer.visible == false) {
			curLayer.visible = true;
			visiList.push(true);
		}
		else {
			visiList.push(false);
		}
	}
	return (visiList);
}

// diese Funktion prft, auf welchen Seiten die Rahmen wie verschoben werden mssen ///////
function adjustPages(evenX, evenY, oddX, oddY, startPageName, endPageName, doLckFrm, doLckLay, doInvLay) {
	// die Masseinheiten in Points festlegen
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	curDoc.viewPreferences.verticalMeasurementUnits   = MeasurementUnits.points;
	var curPage;
	var startPos = curDoc.pages.item(startPageName).documentOffset;
	var endPos   = curDoc.pages.item(endPageName).documentOffset;
	// korrigierend eingreifen, wenn der Startwert grsser als der Stopwert ist
	if (startPos < endPos) {
		var startVal = startPos;
		var stopVal  = endPos+1;
	}
	else {
		var startVal = endPos;
		var stopVal  = startPos+1;
	}		
	// eine Schleife durch die gewhlten Seiten
	for (var ctr=startVal; ctr<stopVal; ctr++) {
		// die aktuelle Seite
		curPage = curDoc.pages.item(ctr);
		if (((curPage.name)*1)%2 == 0) {
			// es ist eine gerade Seitennummer
			adjustPage(curPage, evenX, evenY, doLckFrm, doLckLay, doInvLay);
		}
		else {
			// es ist eine ungerade Seitennummer
			adjustPage(curPage, oddX, oddY, doLckFrm, doLckLay, doInvLay);
		}
	}
}

// diese Funktion adressiert die aktuelle Seite ///////////////////////////////////////////
function adjustPage(curPage, x, y, doLckFrm, doLckLay, doInvLay) {
	var curPageItem, resetItemLock;
	for (var ctr = 0; ctr < curPage.pageItems.length; ctr ++) {
		resetItemLock = false;
		curPageItem = curPage.pageItems.item(ctr);
		if (curPageItem.locked == true) {
			if (doLckFrm == true) {
				curPageItem.locked = false;
				resetItemLock = true;
			}
		}
		if (curPageItem.locked == false && curPageItem.itemLayer.locked == false) {
			if (curPageItem.itemLayer.visible == true) {
				curPageItem.move(undefined, [x, y]);
			}
		}
		if (resetItemLock == true) {
			curPageItem.locked = true;
		}
	}
}

// die Funktion, welche die Seitennummern auflistet ///////////////////////////////////////
function getPageNames() {
	var pageNames = new Array;
	// prfen, ob Abschnitts-Prfizes definiert sind
	var sectPrefs = false;
	var allPrefNames = new Array();
	for (var p=0; p<curDoc.pages.length; p++) {
		var curSect = curDoc.pages[p].appliedSection.name;
		allPrefNames.push(curSect);
	}
	var testString = allPrefNames.join("");
	if (testString.length > 0) {
		sectPrefs = true;
	}
	// die Liste der Seitennummern
	if (sectPrefs == false) {
		pageNames = curDoc.pages.everyItem().name;
	}
	else {
		var pageNames = new Array();
		for (var p=0; p<curDoc.pages.length; p++) {
			var curName = curDoc.pages[p].name;
			pageNames.push(allPrefNames[p] + curName);
		}
	}
	return pageNames;
}

// die Ebenen wieder sperren //////////////////////////////////////////////////////////////
function lockLayers(lockList) {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (lockList[n] == true) {
			curLayer.locked = true;
		}
	}
}

// die Ebenen wieder unsichtbar machen ////////////////////////////////////////////////////
function hideLayers(visiList) {
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	for (var n=0; n<nLayers; n++) {
		var curLayer = allLayers[n];
		if (visiList[n] == true) {
			curLayer.visible = false;
		}
	}
}